import Search_Algorithms
import Sucessors
import is_goal
import Heuristics
import time

# # ===============================================================================================================
# # BREADTH FIRST SEARCH MAZE
# # ===============================================================================================================
# # Maze Problem, note, the maze is fixed in the allowed state.
# print(Search_Algorithms.BreadthFirstSearch(
#     (4, 0), Sucessors.maze_successor, is_goal.is_goal_maze))

# # Sudoku
# grid = ((5, 3, 0, 0, 7, 0, 0, 0, 0),
#         (6, 0, 0, 1, 9, 5, 0, 0, 0),
#         (0, 9, 8, 0, 0, 0, 0, 6, 0),
#         (8, 0, 0, 0, 6, 0, 0, 0, 3),
#         (4, 0, 0, 8, 0, 3, 0, 0, 1),
#         (7, 0, 0, 0, 2, 0, 0, 0, 6),
#         (0, 6, 0, 0, 0, 0, 2, 8, 0),
#         (0, 0, 0, 4, 1, 9, 0, 0, 5),
#         (0, 0, 0, 0, 8, 0, 0, 0, 0))

# # ===============================================================================================================
# # BREADTH FIRST SEARCH SUDOKU
# # ===============================================================================================================
# sln = (Search_Algorithms.BreadthFirstSearch(
#     grid, Sucessors.sudoku_successor, is_goal.is_goal_sudoku)[-1])

# for rows in sln:
#     print(rows)

# # ===============================================================================================================
# # DEPTH FIRST SEARCH SUDOKU
# # ===============================================================================================================
# sln = (Search_Algorithms.DepthFirstSearch(
#     grid, Sucessors.sudoku_successor, is_goal.is_goal_sudoku)[-1])
# #
# for rows in sln:
#     print(rows)

#
board = ((False, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, False),
         (True, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, True))

# ===============================================================================================================
# BREADTH FIRST SEARCH N QUEENS PROBLEM
# ===============================================================================================================
start_time = time.time()
sln = (Search_Algorithms.BreadthFirstSearch(
    board, Sucessors.queens_successor, is_goal.is_goal_queens)[-1])

output_tuple = tuple(tuple("Q" if value else "." for value in sln)
                     for sln in sln)
for rows in output_tuple:
    print(rows)
end_time = time.time()
print(end_time - start_time)


# ===============================================================================================================
# DEPTH FIRST SEARCH N-QUEENS
# ===============================================================================================================
start_time = time.time()
sln = (Search_Algorithms.DepthFirstSearch(
    board, Sucessors.queens_successor, is_goal.is_goal_queens)[-1])

output_tuple = tuple(tuple("Q" if value else "." for value in sln)
                     for sln in sln)
for rows in output_tuple:
    print(rows)
end_time = time.time()
print(end_time - start_time)

# # # Sliding Puzzle
# initial_puzzle = (
#     (7, 2, 4),
#     (5, 0, 6),
#     (8, 3, 1)
# )
# # ===============================================================================================================
# # BREADTH FIRST SEARCH PUZZLE PROBLEM
# # ===============================================================================================================
# sln = (Search_Algorithms.BreadthFirstSearch(initial_puzzle,
#        Sucessors.puzzle_successor, is_goal.is_goal_puzzle))

# if sln:
#     for rows in sln:
#         for r in rows:
#             print(r)
# else:
#     print("No solution found")


# # ===============================================================================================================
# # DEPTH FIRST SEARCH PUZZLE PROBLEM
# # search was timed on Michael's computer and took 211 seconds, Please be patient
# # ===============================================================================================================
# # start_time = time.time()
# sln = (Search_Algorithms.DepthFirstSearch(initial_puzzle,
#        Sucessors.puzzle_successor, is_goal.is_goal_puzzle)[-1])
# # end_time = time.time()
# # print(end_time - start_time)

# if sln:
#     for rows in sln:
#         print(rows)
# else:
#     print("No solution found")


# # ===============================================================================================================
# # A* SEARCH MAZE PROBLEM
# # ===============================================================================================================
# print(Search_Algorithms.A_StarSearch((4, 0), Sucessors.maze_successor,
#       is_goal.is_goal_maze, Heuristics.maze_opt))


# # # ===============================================================================================================
# # # A* SEARCH SUDOKU
# # # ===============================================================================================================
# sln = (Search_Algorithms.A_StarSearch(grid, Sucessors.sudoku_successor,
#                                       is_goal.is_goal_sudoku, Heuristics.sudoku_opt))[-1]

# for rows in sln:
#     print(rows)


# # =================================================================================================================
# # A* SEARCH PUZZLE
# # =================================================================================================================
# sln = (Search_Algorithms.A_StarSearch(initial_puzzle, Sucessors.puzzle_successor,
#                                       is_goal.is_goal_puzzle, Heuristics.puzzle_opt))[-1]

# if sln:
#     for rows in sln:
#         print(rows)
# else:
#     print("No solution found")


# # # ===============================================================================================================
# # # A* SEARCH QUEENS
# # # ===============================================================================================================

board = ((False, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, False),
         (True, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, False),
         (False, False, False, False, False, False, False, False, False, True))


start_time = time.time()
sln = (Search_Algorithms.A_StarSearch(board, Sucessors.queens_successor,
       is_goal.is_goal_queens, Heuristics.queens_opt))[-1]

output_tuple = tuple(tuple("Q" if value else "." for value in sln)
                     for sln in sln)
for rows in output_tuple:
    print(rows)

end_time = time.time()
print(end_time - start_time)